#include  <stdlib.h>
#include  <string.h>
#include  <stdio.h>
#include  <io.h>
#include  <signal.h>

#include "lanimacros.h"
//#include "watchdogclock.h"
//#include "uart.h"
#include "display.h"
#include "mmc.h"
#include "fat.h"



unsigned char sectorbuffer[512];
unsigned long sector_in_buffer;


// aus der Partitionstabelle im MBR


PARTITION SD[4];

PARTITION * aktuelle_partition = &SD[1];		// globaler Pointer auf aktuelle Partition für Pfadangaben
unsigned int aktuelles_verzeichnis = 0;			// globaler Startcluster des aktuellen Verzeichnisses 

void init_DOS(void)
{
		
	unsigned long speicherplatz;
	unsigned int f;
	
	displaycolor(COLOR_RED,COLOR_BLACK);

	while ( mmc_init() !=0) //ist der Rckgabewert ungleich NULL ist ein Fehler aufgetreten
	{
		uprintf(display_putc,"Keine SD Karte gefunden!\n\r");	
	}
	
	//uprintf(display_putc,"Karte gefunden!!\n\r");
	
	
	read_MBR(&SD[0],0x1BE);		//PARTITION 1	= 0x1BE im Masterbootrecord
	read_MBR(&SD[1],0x1CE);		//PARTITION 2	= 0x1CE im Masterbootrecord
	read_MBR(&SD[2],0x1DE);		//PARTITION 3	= 0x1DE im Masterbootrecord
	read_MBR(&SD[3],0x1EE);		//PARTITION 4	= 0x1EE im Masterbootrecord
	
	read_VBR(&SD[0]);
	read_VBR(&SD[1]);
	read_VBR(&SD[2]);
	read_VBR(&SD[3]);
	
	displaycolor(COLOR_GREEN,COLOR_BLACK);
	
	
	for(f=0;f<=3;f++)
	{
		speicherplatz = (SD[f].sectoren_in_partition + SD[f].sectoren_pro_partition_klein) * SD[f].bytes_pro_sector;
		speicherplatz = speicherplatz/1000000;
		uprintf(display_putc,"PARTITION %d: %ld MB\r\n",f,speicherplatz);
		//uprintf(display_putc,"%d SEC/CLUSTER\r\n",SD[f].sectoren_pro_cluster);
	}
	
	displaycolor(COLOR_WHITE,COLOR_BLACK);
}

void loadtxt(unsigned char *ladename)
{
	unsigned int buchstabe,f;
	
		
	DATEI text;
	
	f = fopen (&text,ladename);
	if(f != 0)
	{
		printf("\r\n>%s< nicht gefunden!\r\n", ladename);
		return;
	}
	
	while(1)
	{
		buchstabe=fgetc(&text);
		if(buchstabe==0xffff)
			return;
		printf("%c",buchstabe);
		//uprintf(display_putc,"%c",buchstabe);
	}
	return;
}

void cd(unsigned char *ladename)
{
	unsigned int f;
	
		
	DATEI dummy;
	
	f = fopen (&dummy,ladename);
	if(f != 0)
	{
		printf("\r\n>%s< nicht gefunden!\r\n", ladename);
	}
	

	return;
}

void loadbmp(unsigned int x1, unsigned int y1, unsigned char *ladename)
{
	
	
	unsigned int x2, y2;
	unsigned int r,g,b;
	unsigned int farbe;
	//unsigned int bitzaehler=0;
	unsigned int f,n;
	
	unsigned int		bfType;
	unsigned long  		bfSize;
	unsigned long  		bfReserved;
	unsigned long  		bfOffBits;

	unsigned long  		biSize;
	long  				biWidth;
	long  				biHeight;
	unsigned int  		biPlanes;
	unsigned int  		biBitCount;
	unsigned long  		biCompression;
	unsigned long  		biSizeImage;
	long  				biXPelsPerMeter;
	long  				biYPelsPerMeter;
	unsigned long  		biClrUsed;
	unsigned long  		biClrImportant;
	
	
	DATEI bild;
	
	
	f = fopen (&bild,ladename);
	if(f != 0)
	{
		printf("\r\n>%s< nicht gefunden!\r\n", ladename);
		return;
	}
	
	
	
	bfType     =  fread_word(&bild);
	bfSize     =  fread_doubleword(&bild);
	bfReserved =  fread_doubleword(&bild);
	bfOffBits  =  fread_doubleword(&bild);
	
	biSize 			= fread_doubleword(&bild);
	biWidth			= fread_doubleword(&bild);
	biHeight 		= fread_doubleword(&bild);
	biPlanes 		= fread_word(&bild);
	biBitCount 		= fread_word(&bild);
	biCompression 	= fread_doubleword(&bild);
	biSizeImage 	= fread_doubleword(&bild);
	biXPelsPerMeter	= fread_doubleword(&bild);
	biYPelsPerMeter = fread_doubleword(&bild);
	biClrUsed		= fread_doubleword(&bild);
	biClrImportant	= fread_doubleword(&bild);
	 
	printf("bfType 			= %d;\n",bfType);
	printf("bfSize 			= %ld;\n",bfSize);
	printf("bfReserved 		= %ld;\n",bfReserved);
	printf("bfOffBits 		= %ld;\n",bfOffBits);
	printf("biSize 			= %ld;\n",biSize);
	printf("biWidth			= %ld;\n",biWidth);
	printf("biHeight 		= %ld;\n",biHeight);
	printf("biPlanes 		= %d;\n",biPlanes);
	printf("biBitCount 		= %d;\n",biBitCount);
	printf("biCompression 	= %ld;\n",biCompression);
	printf("biSizeImage		= %ld;\n",biSizeImage);
	printf("biXPelsPerMeter	= %ld;\n",biXPelsPerMeter);
	printf("biYPelsPerMeter	= %ld;\n",biYPelsPerMeter);
	printf("biClrUsed 		= %ld;\n",biClrUsed);
	printf("biClrImportant	= %ld;\n",biClrImportant);
	
	
	
	
	
	
	//bitzaehler=54;
	//hier sollte man den Filezeiger auf bfOffBits setzen
	
	
	
	
	x2 = biWidth  + x1 - 1; 
	y2 = biHeight + y1 - 1;
	
		
	
	displaycommand(0x0504);
	displaycommand(0x0800+y1);
	displaycommand(0x0900+y2);
	displaycommand(0x0A00+x1);
	displaycommand(0x0B00+x2);
	 
	if(biBitCount == 24)
	{
		
		for(f=y1;f<=y2;f++)
		{
			for(n=x1;n<=x2;n++)
			{
				b = fgetc(&bild);
				g = fgetc(&bild);
				r = fgetc(&bild);
			
				r = (r & 0xF8)<<8;
				g = (g & 0xFC)<<3;
				b = (b & 0xF8)>>3;
	
				farbe= r|g|b;
			
				displaydata(farbe);
			}
			r = biWidth % 4;
			if(r != 0)
			{
				for(n=0;n<r;n++)
				{
					fgetc(&bild);
				}
			}
		
		}	
		return;
	}
	
	if(biBitCount == 8)
	{
		
		unsigned int dummy;
		unsigned int farbtabelle[256];
		
		for(f=0;f<biClrUsed;f++)
		{
			b = fgetc(&bild);
			g = fgetc(&bild);
			r = fgetc(&bild);
			dummy = fgetc(&bild);
			
			r = (r & 0xF8)<<8;
			g = (g & 0xFC)<<3;
			b = (b & 0xF8)>>3;
	
			farbe= r|g|b;
			
			farbtabelle[f]=farbe;
		}	
		
		dummy = biWidth % 4;
		
		if (biCompression == 0)
		{
			
			//fseek(bmpdatei,bfOffBits+(y*(biWidth + (biWidth % 4))),SEEK_SET);
			
			
			for(f=y1;f<=y2;f++)
			{
				for(n=x1;n<=x2;n++)
				{
					displaydata(farbtabelle[fgetc(&bild)]);
				}
				
				if (dummy != 0)					// ueberfluessige Bytes am Zeilenende verwerfen
				{
					//dummy = 4 - dummy;
					for(n=0;n<(4-dummy);n++)
					{
						fgetc(&bild);
					}	
				}
				
			}
			return;
		}
			
		else
		{
			unsigned char wert1,wert2;
			
			do
			{
				wert1= fgetc(&bild);
				wert2= fgetc(&bild);
				
				if(wert1 !=0)
				{
					for(f=0;f<wert1;f++)
					{
						displaydata(farbtabelle[wert2]);
					}
				}
				else
				{
					switch (wert2)
					{
					case  0:                // Ende der Zeile
						nop();				// wird durch das Clipping nicht gebraucht
						break;
					case  1:                // Ende der Bitmap
						return;				// Funktion beenden                              
					case  2: 			 	// Verschiebung der aktuellen Pixelposition...
						nop();				// wird nicht unterstuetzt...
						break;
					default:				// n unkomprimierte daten
					
						for(f=0;f<wert2;f++)
						{
							displaydata(farbtabelle[fgetc(&bild)]);
						}
						if((wert2 % 2) !=0)
						{
							fgetc(&bild);
						}
					}
				}
			}while(1); //while(zaehler<test_biSizeImage);
		}
	}
	
	printf("\r\nFalsches Format!\r\n");
}

unsigned int fread_word(DATEI * datei)
{
	unsigned int wert,teil1,teil2;
	
	teil1 = fgetc(datei);
	teil2 = fgetc(datei);
	
	wert = teil1 + (teil2<<8);
	
	return wert;
	
}
//liest 32Bit-Wert aus dem Buffer
unsigned long fread_doubleword(DATEI * datei)
{
	unsigned long wert;
	unsigned int teil1,teil2,teil3,teil4;
	
	teil1 = fgetc(datei);
	teil2 = fgetc(datei);
	teil3 = fgetc(datei);
	teil4 = fgetc(datei);
	
	wert = teil4;
	wert = wert<<8;
	wert = wert + teil3;
	wert = wert<<8;
	wert = wert + teil2;
	wert = wert<<8;
	wert = wert + teil1;
	
	return wert;
}
unsigned int fopen(DATEI * datei, unsigned char *filename)
{
	char workbuffer[80];
	char *trennzeichen = "/";
	char *workzeiger;
	
	unsigned int findreturn;
	
	datei->verzeichnis.erster_cluster = aktuelles_verzeichnis;
	datei->part = aktuelle_partition;
	
	
	datei->verzeichnis.name[11]=0;
	datei->eintrag.name[11]=0;
	
	
	
	strcpy(workbuffer, filename);
	
	for (workzeiger = strtok(workbuffer, trennzeichen); workzeiger ;workzeiger = strtok(NULL, trennzeichen))
	{
			   //printf("Befehl: %s\n", workzeiger);
		strtoupper(workzeiger);
		
		if(workzeiger[3]==':')
		{
			if (strcmp(workzeiger , "SD1:") == 0)
				datei->part = &SD[0];
		
			if (strcmp(workzeiger , "SD2:") == 0)
				datei->part = &SD[1];
			
		
			if (strcmp(workzeiger , "SD3:") == 0)
				datei->part = &SD[2];
				
		
			if (strcmp(workzeiger , "SD4:") == 0)
				datei->part = &SD[3];
			
			aktuelle_partition = datei->part;
			aktuelles_verzeichnis = 0;
			
			datei->verzeichnis.erster_cluster = 0;
			
			printf("%s\r\n",workzeiger);
		}
		else
		{
			findreturn = file_find(datei,workzeiger);
			
			if(findreturn != 0)
			{
				printf("\r\nDatei >%s< nicht gefunden!\r\n",workzeiger);
				return 1;
			}
			
			printf("ORDNER: %s   %d\r\n",datei->verzeichnis.name, datei->verzeichnis.erster_cluster);
			printf("DATEI:  %s   %d\r\n",datei->eintrag.name, datei->eintrag.erster_cluster);
			
		}
		

	}
	
	datei->zeichen_pos_in_datei=0;
	datei->zeichen_pos_im_sector=0;
	datei->sector_im_cluster=0;
	datei->cluster_vom_file=0;
	datei->aktueller_cluster = datei->eintrag.erster_cluster;
	
	
	datei->sector = datei->part->start_daten + ((datei->eintrag.erster_cluster - 2) * datei->part->sectoren_pro_cluster);	// ersten Sector/Cluster ausrechnen
	mmc_read_sector(datei->sector,sectorbuffer);			
	
	printf("\r\n");
	return 0;
	
											// und lesen
	
	
	
}
unsigned int fgetc(DATEI * datei)
{
	
	unsigned char wert;
	if(datei->zeichen_pos_in_datei==datei->eintrag.groesse)  			// alle Zeichen sinf gelesen
	{
		return 0xffff;
	}
	
	if(datei->zeichen_pos_im_sector == datei->part->bytes_pro_sector)		// letztes Byte im Sector ist gelesen
	{
		datei->zeichen_pos_im_sector=0;
		datei->sector_im_cluster++;
		
		if(datei->sector_im_cluster == datei->part->sectoren_pro_cluster)	// letzter Sector im Cluster ist gelesen
		{
			datei->sector_im_cluster=0;
			datei->cluster_vom_file++;
			datei->aktueller_cluster = find_next_cluster(datei->part, datei->aktueller_cluster);
		}
		
		datei->sector = datei->part->start_daten + ((datei->aktueller_cluster  -2) * datei->part->sectoren_pro_cluster) + datei->sector_im_cluster;	// ersten Sector/Cluster ausrechnen
		
		mmc_read_sector(datei->sector,sectorbuffer);	
		
	}
	
	wert=sectorbuffer[datei->zeichen_pos_im_sector];
	
	datei->zeichen_pos_im_sector++;
	datei->zeichen_pos_in_datei++;
	
	return wert;
}
unsigned int file_find(DATEI * datei, unsigned char *filename)
{
	
	
	unsigned int  f,n;
	
	
	unsigned long verzeichnis_sector;
	unsigned int  verzeichnis_aktueller_cluster;
	
	VERZEINTRAG gefunden;
	
	unsigned char echtname[12];
	
	makerealname(filename,echtname);
	
	printf("\r\nDateien:\r\n");
	
	if(datei->verzeichnis.erster_cluster != 0x0000)				// das root-Verzeichnis hat startcluster 0
	{

		verzeichnis_aktueller_cluster = datei->verzeichnis.erster_cluster;

		while(1)
		{
	
			for(n=0;n < datei->part->sectoren_pro_cluster ; n++) // (part->max_eintraege_hauptverzeichnis * 32 / 512)
			{
	
				verzeichnis_sector = datei->part->start_daten + ((verzeichnis_aktueller_cluster  -2) * datei->part->sectoren_pro_cluster) + n;
		
				printf("Sector: %ld  Nummer: %d\r\n",verzeichnis_sector,n);
			
				mmc_read_sector (verzeichnis_sector,sectorbuffer);
	
				for(f=0;f<511;f=f+32)			// jeder Eintrag hat 32 Byte
				{
					if(sectorbuffer[f]==0)
						return 1;
				
			//if((attribute != ATTR_LONG_NAME)&&(dateigroesse !=0))
					if (strncmp(echtname ,sectorbuffer + f,11) == 0)
					{
						gefunden.erster_cluster = sector_getword(f+26);
						gefunden.attribute		= sectorbuffer[f+11];
						gefunden.groesse 		= sector_getdoubleword(f+28);
						strncpy(gefunden.name,sectorbuffer + f,11);	
						gefunden.name[11]= 0;	
					
						if(gefunden.attribute == ATTR_DIRECTORY)
						{
							datei->verzeichnis.erster_cluster 	= gefunden.erster_cluster;
							datei->verzeichnis.attribute      	= gefunden.attribute;
							datei->verzeichnis.groesse 			= gefunden.groesse;
							strncpy(datei->verzeichnis.name, gefunden.name,11);	
							aktuelles_verzeichnis = datei->verzeichnis.erster_cluster;
						}
						else
						{
							datei->eintrag.erster_cluster 	= gefunden.erster_cluster;
							datei->eintrag.attribute      	= gefunden.attribute;
							datei->eintrag.groesse 		= gefunden.groesse;
							strncpy(datei->eintrag.name, gefunden.name,11);	
						}
						printf("%s  0x%02x 0x%04x (%d) %ld \r\n",gefunden.name,gefunden.attribute,gefunden.erster_cluster,gefunden.erster_cluster,gefunden.groesse);
						return 0;
					}
				}
			}
		
			verzeichnis_aktueller_cluster = find_next_cluster(datei->part,verzeichnis_aktueller_cluster);
			if (verzeichnis_aktueller_cluster == 0xFFFF)
			{
				printf("dir Ende\r\n");
				return 1;
			}
		}
	}
	else
	{
		unsigned int  sectoren_root = (datei->part->max_eintraege_hauptverzeichnis * 32 / datei->part->bytes_pro_sector);
	
		for(n=0;n < sectoren_root ; n++) // (datei->part->max_eintraege_hauptverzeichnis * 32 / 512)
		{
			printf("Sector: %ld  Nummer: %d\r\n",datei->part->start_verz_eintraege + n,n);
	
			mmc_read_sector (datei->part->start_verz_eintraege + n,sectorbuffer);
	
			for(f=0;f<511;f=f+32)			// jeder Eintrag hat 32 Byte
			{
				if(sectorbuffer[f]==0)
					return 1;
				
			//if((attribute != ATTR_LONG_NAME)&&(dateigroesse !=0))
				if (strncmp(echtname ,sectorbuffer + f,11) == 0)
				{
					gefunden.erster_cluster = sector_getword(f+26);
					gefunden.attribute		= sectorbuffer[f+11];
					gefunden.groesse 		= sector_getdoubleword(f+28);
					strncpy(gefunden.name,sectorbuffer + f,11);	
					gefunden.name[11]= 0;	
					
					if(gefunden.attribute == ATTR_DIRECTORY)
					{
						datei->verzeichnis.erster_cluster 	= gefunden.erster_cluster;
						datei->verzeichnis.attribute      	= gefunden.attribute;
						datei->verzeichnis.groesse 			= gefunden.groesse;
						strncpy(datei->verzeichnis.name, gefunden.name,11);	
						
						aktuelles_verzeichnis = datei->verzeichnis.erster_cluster;
					}
					else
					{
						datei->eintrag.erster_cluster 	= gefunden.erster_cluster;
						datei->eintrag.attribute      	= gefunden.attribute;
						datei->eintrag.groesse 		= gefunden.groesse;
						strncpy(datei->eintrag.name, gefunden.name,11);	
					}
					printf("%s  0x%02x 0x%04x (%d) %ld \r\n",gefunden.name,gefunden.attribute,gefunden.erster_cluster,gefunden.erster_cluster,gefunden.groesse);
					return 0;
				}
			}
		}
		printf("root Ende\r\n");
		return 1;
	}
	
	return 1;


	
}
unsigned int fwrite(unsigned char *filename)
{
	DATEI test;
	
	test.verzeichnis.erster_cluster = aktuelles_verzeichnis;
	test.part = aktuelle_partition;

	test.verzeichnis.name[11]=0;
	test.eintrag.name[11]=0;
	
	test.zeichen_pos_in_datei=0;
	test.zeichen_pos_im_sector=0;
	test.sector_im_cluster=0;
	test.cluster_vom_file=0;
	test.aktueller_cluster = test.eintrag.erster_cluster;
	
	find_free_FAT(&test, filename);
	find_free_cluster(test.part, 0);
	//test.sector = test.part->start_daten + ((test.eintrag.erster_cluster - 2) * test.part->sectoren_pro_cluster);	// ersten Sector/Cluster ausrechnen
	//mmc_read_sector(test.sector,sectorbuffer);	
	
	return 0;
}

unsigned int find_free_cluster(PARTITION * part, unsigned int alter_cluster)
{
	unsigned int neuer_cluster;
	unsigned int fat_sector_nr;
	unsigned int sektor_eintrag_nr;
	
	unsigned int f,n,inhalt;
	
	for(n=0;n < part->sectoren_pro_fat;n++)
	{
		mmc_read_sector(part->start_fat + n,sectorbuffer);
		
		for(f=0;f<511;f=f+2)
		{
			inhalt= sector_getword(f);
			printf("%d\r\n",inhalt);
			
			if(inhalt==0)
				goto gefunden;
		}
		
	
		
	}
	
	
	printf("Kein freier Cluster gefunden\r\n");
	
	return 0xffff;
	
	gefunden:
	//freier_cluster= (n*256)+(f/2);
	
	
	
	fat_sector_nr = alter_cluster/256;			// in welchem Sector der FAT
	sektor_eintrag_nr = alter_cluster % 256;	// an welcher Stelle
	
	mmc_read_sector(part->start_fat + fat_sector_nr,sectorbuffer);
	
	neuer_cluster = sector_getword(sektor_eintrag_nr * 2);
	
	//printf(" Cluster: 0x%04X (%d)\r\n", neuer_cluster, neuer_cluster);
	
	return neuer_cluster;
}


unsigned int find_free_FAT(DATEI * datei, unsigned char *filename)
{
	
	
	unsigned int  f,n;
	
	
	unsigned long verzeichnis_sector;
	unsigned int  verzeichnis_aktueller_cluster;
	
	VERZEINTRAG gefunden;
	
	unsigned char echtname[12];
	
	makerealname(filename,echtname);
	
	printf("\r\nDateien:\r\n");
	
	if(datei->verzeichnis.erster_cluster != 0x0000)				// das root-Verzeichnis hat startcluster 0
	{

		verzeichnis_aktueller_cluster = datei->verzeichnis.erster_cluster;

		while(1)
		{
	
			for(n=0;n < datei->part->sectoren_pro_cluster ; n++) // (part->max_eintraege_hauptverzeichnis * 32 / 512)
			{
	
				verzeichnis_sector = datei->part->start_daten + ((verzeichnis_aktueller_cluster  -2) * datei->part->sectoren_pro_cluster) + n;
		
				printf("Sector: %ld  Nummer: %d\r\n",verzeichnis_sector,n);
			
				mmc_read_sector (verzeichnis_sector,sectorbuffer);
	
				for(f=0;f<511;f=f+32)			// jeder Eintrag hat 32 Byte
				{
					if((sectorbuffer[f]==0)||(sectorbuffer[f]==229))
					{
						gefunden.erster_cluster = sector_getword(f+26);
						gefunden.attribute		= sectorbuffer[f+11];
						gefunden.groesse 		= sector_getdoubleword(f+28);
						strncpy(gefunden.name,sectorbuffer + f,11);	
						gefunden.name[11]= 0;
					
						printf("%s  0x%02x 0x%04x (%d) %ld \r\n",gefunden.name,gefunden.attribute,gefunden.erster_cluster,gefunden.erster_cluster,gefunden.groesse);
						return 0;
					}
				}
			}
		
			verzeichnis_aktueller_cluster = find_next_cluster(datei->part,verzeichnis_aktueller_cluster);
			if (verzeichnis_aktueller_cluster == 0xFFFF)
			{
				printf("kein Platz in Verzeichnis\r\n");
				return 1;
			}
		}
	}
	else
	{
		unsigned int  sectoren_root = (datei->part->max_eintraege_hauptverzeichnis * 32 / datei->part->bytes_pro_sector);
	
		for(n=0;n < sectoren_root ; n++) // (datei->part->max_eintraege_hauptverzeichnis * 32 / 512)
		{
			printf("Sector: %ld  Nummer: %d\r\n",datei->part->start_verz_eintraege + n,n);
	
			mmc_read_sector (datei->part->start_verz_eintraege + n,sectorbuffer);
	
			for(f=0;f<511;f=f+32)			// jeder Eintrag hat 32 Byte
			{
				if((sectorbuffer[f]==0)||(sectorbuffer[f]==229))
				{
					gefunden.erster_cluster = sector_getword(f+26);
					gefunden.attribute		= sectorbuffer[f+11];
					gefunden.groesse 		= sector_getdoubleword(f+28);
					strncpy(gefunden.name,sectorbuffer + f,11);	
					gefunden.name[11]= 0;
					
					printf("%s  0x%02x 0x%04x (%d) %ld \r\n",gefunden.name,gefunden.attribute,gefunden.erster_cluster,gefunden.erster_cluster,gefunden.groesse);
					return 0;
				}
			}
		}
		printf("kein Platz in root\r\n");
		return 1;
	}
	
	return 1;


	
}

void strtoupper(unsigned char * zeiger)
{
	unsigned int f,n;
	
	n = strlen(zeiger);
	
	for(f=0;f<n;f++)
	{
		if((zeiger[f] >= 'a') && (zeiger[f] <= 'z'))
		{
			zeiger[f] = zeiger[f] - ('a'-'A');
		} 
	}
}



void makerealname(unsigned char * altername,unsigned char * neuername)
{
	unsigned int f,n=0;
	
	if(strlen(altername)>12)
		return;
	
	
	
	for(f=0;f<11;f++)
	{
		neuername[f]=' ';
	}
	
	neuername[11] = 0;
	
	if (strcmp(altername, ".") == 0)
	{
		neuername[0]='.';
		return;
	}
	
	if (strcmp(altername, "..") == 0)
	{
		neuername[0]='.';
		neuername[1]='.';
		return;
	}
	
	for(f=0;f< strlen(altername);f++)
	{
		if(altername[f]=='.')
		{
			n=8;
		}
		else
		{
			neuername[n]=altername[f];
			n++;
		}
	}	
	
	strtoupper(neuername);
}

PARTITION* getpartition(unsigned char *filepfad)
{
	if (strncmp(filepfad , "SD1:", 4) == 0)
		return &SD[0];
		
	if (strncmp(filepfad , "SD2:", 4) == 0)
		return &SD[1];
			
		
	if (strncmp(filepfad , "SD3:", 4) == 0)
		return &SD[2];
				
		
	if (strncmp(filepfad , "SD4:", 4) == 0)
		return &SD[3];
	
	return &SD[0];
}

void read_MBR(PARTITION * part,unsigned int offset)
{
	mmc_read_sector ((unsigned long) 0,sectorbuffer);								//Sektor auslesen
	
	//part->typ    			= sectorbuffer		  [offset + 0x04];		// 0x01=FAT12	0x04=FAT16<32MB	0x06=FAT16>32MB	0x0b=FAT32	
	part->erster_sector 			= sector_getdoubleword(offset + 0x08);		// Abstand zwischen MBR und dem ersten Sektor der Partition
	//part->anzahl_sektoren 	= sector_getdoubleword(offset + 0x0C);		// Anzahl der Sektoren in der Partition
	
}

void read_VBR(PARTITION * part)
{
	mmc_read_sector (part->erster_sector,sectorbuffer);	
	
	part->bytes_pro_sector 				= sector_getword		(0x0b);	// Bytes pro Sector auf der Festplatte
	part->sectoren_pro_cluster 			= sectorbuffer			[0x0d];	// Sectoren pro Cluster
	part->reservierte_sectoren 			= sector_getword		(0x0e);	// Anzahl der reservierten Sectoren
	part->kopien_der_fat 					= sectorbuffer			[0x10];	// normalerweise 2
	part->max_eintraege_hauptverzeichnis 	= sector_getword		(0x11);	// 512 bei FAT16
	part->sectoren_pro_partition_klein	= sector_getword		(0x13);	// in kleinen Partitionen
	//part->plattentyp					 	= sectorbuffer			[0x15];	// F8 Festplatte, F0 Diskette
	part->sectoren_pro_fat 				= sector_getword		(0x16);	// Sectoren pro Fat
	//part->sectoren_pro_track 				= sector_getword		(0x18);	// Sectoren pro Track
	//part->anzahl_der_koepfe 				= sector_getword		(0x1a);	// Anzagl der Koepfe
	part->reservierte_sectoren_anfang 	= sector_getdoubleword	(0x1c);	// Reservierte Sectoren am Anfang der Platte
	part->sectoren_in_partition 			= sector_getdoubleword	(0x20);	// Gesamtzahl der Sectoren in der Partition
	//part->laufwerknummer 					= sector_getword		(0x24);	// erste Platte 0x80, zweite 0x81 usw
	//part->erweiterte_signatur 			= sectorbuffer			[0x26];	// 0x29
	//part->seriennummer 					= sector_getdoubleword	(0x27);	// Seriennummer des Datentraegers
	//strncpy(part->datentreagername,sectorbuffer + 0x2b,11);	// Laufwerk Name
	//strncpy(part->fatname,sectorbuffer + 0x36,8);
	//part->signatur 						= sector_getword		(0x1fe);// 0x55AA
	
	part->start_fat  				= part->erster_sector + part->reservierte_sectoren;
	part->start_verz_eintraege 		= part->start_fat + part->sectoren_pro_fat * part->kopien_der_fat;
	//part->start_daten				= part->start_verz_eintraege + 32;
	part->start_daten				= part->start_verz_eintraege + (part->max_eintraege_hauptverzeichnis * 32)/part->bytes_pro_sector ;
	
}


//void dir(PARTITION * part, unsigned int verzeichnis_start_cluster)
void dir(void)
{
	
	
	unsigned int  f,n;
	
	unsigned int verzeichnis_start_cluster = aktuelles_verzeichnis;
	unsigned long verzeichnis_sector;
	unsigned int  verzeichnis_aktueller_cluster;
	
	PARTITION * part = aktuelle_partition;
	VERZEINTRAG gefunden;
	
	printf("\r\nDateien:\r\n");
	
	if(verzeichnis_start_cluster != 0x0000)				// das root-Verzeichnis hat startcluster 0
	{

		verzeichnis_aktueller_cluster = verzeichnis_start_cluster;

		while(1)
		{
	
			for(n=0;n < part->sectoren_pro_cluster ; n++) // (part->max_eintraege_hauptverzeichnis * 32 / 512)
			{
	
				verzeichnis_sector = part->start_daten + ((verzeichnis_aktueller_cluster  -2) * part->sectoren_pro_cluster) + n;
		
				printf("Sector: %ld  Nummer: %d\r\n",verzeichnis_sector,n);
			
				mmc_read_sector (verzeichnis_sector,sectorbuffer);
	
				for(f=0;f<511;f=f+32)			// jeder Eintrag hat 32 Byte
				{
					if(sectorbuffer[f]==0)
						return;
					
					gefunden.attribute=sectorbuffer[f+11];
					gefunden.groesse = sector_getdoubleword(f+28);
				
			//if((attribute != ATTR_LONG_NAME)&&(dateigroesse !=0))
					if((gefunden.attribute != ATTR_LONG_NAME)&&(sectorbuffer[f]!= 229))		// 229 = geloescht
					{
						gefunden.erster_cluster = sector_getword(f+26);
				
			
						strncpy(gefunden.name,sectorbuffer + f,11);
						gefunden.name[11]= 0;		
						printf("%s 0x%02x 0x%04x (%d) %ld \r\n",gefunden.name,gefunden.attribute,gefunden.erster_cluster,gefunden.erster_cluster,gefunden.groesse);
					}
				}
			}
		
			verzeichnis_aktueller_cluster = find_next_cluster(part,verzeichnis_aktueller_cluster);
			if (verzeichnis_aktueller_cluster == 0xFFFF)
			{
				printf("dir Ende\r\n");
				return;
			}
		}
	}
	else
	{
		unsigned int  sectoren_root = (part->max_eintraege_hauptverzeichnis * 32 / part->bytes_pro_sector);
	
		for(n=0;n < sectoren_root ; n++) // (part->max_eintraege_hauptverzeichnis * 32 / 512)
		{
			printf("Sector: %ld  Nummer: %d\r\n",part->start_verz_eintraege + n,n);
	
			mmc_read_sector (part->start_verz_eintraege + n,sectorbuffer);
	
			for(f=0;f<511;f=f+32)			// jeder Eintrag hat 32 Byte
			{
				if(sectorbuffer[f]==0)
					return;
				
				gefunden.attribute=sectorbuffer[f+11];
				gefunden.groesse = sector_getdoubleword(f+28);
				
			//if((attribute != ATTR_LONG_NAME)&&(dateigroesse !=0))
				if((gefunden.attribute != ATTR_LONG_NAME)&&(sectorbuffer[f]!= 229))
				{
					gefunden.erster_cluster = sector_getword(f+26);
				
			
					strncpy(gefunden.name,sectorbuffer + f,11);	
					gefunden.name[11]= 0;	
	
					printf("%s  0x%02x 0x%04x (%d) %ld \r\n",gefunden.name,gefunden.attribute,gefunden.erster_cluster,gefunden.erster_cluster,gefunden.groesse);
				}
			}
		}
		printf("root Ende\r\n");
	}
	


	
}

unsigned int find_next_cluster(PARTITION * part, unsigned int alter_cluster)
{
	unsigned int neuer_cluster;
	unsigned int fat_sector_nr;
	unsigned int sektor_eintrag_nr;
	
	fat_sector_nr = alter_cluster/256;			// in welchem Sector der FAT
	sektor_eintrag_nr = alter_cluster % 256;	// an welcher Stelle
	
	mmc_read_sector(part->start_fat + fat_sector_nr,sectorbuffer);
	
	neuer_cluster = sector_getword(sektor_eintrag_nr * 2);
	
	//printf(" Cluster: 0x%04X (%d)\r\n", neuer_cluster, neuer_cluster);
	
	return neuer_cluster;
}

// liest 16Bit-Wert aus dem Buffer
unsigned int sector_getword(unsigned int offset)
{
	unsigned int wert;
	
	wert = sectorbuffer[offset] + (sectorbuffer[offset+1]<<8);
	return wert;
	
}
//liest 32Bit-Wert aus dem Buffer
unsigned long sector_getdoubleword(unsigned int offset)
{
	unsigned long wert;
	wert = sectorbuffer[offset+3];
	wert = wert<<8;
	wert = wert + sectorbuffer[offset+2];
	wert = wert<<8;
	wert = wert + sectorbuffer[offset+1];
	wert = wert<<8;
	wert = wert + sectorbuffer[offset];
	
	return wert;
}

void hexmon(unsigned long nummer)
{
	unsigned int f,n;
	mmc_read_sector ((unsigned long) nummer,sectorbuffer);
	for(f=0;f<348;f++)
	{
		if((sectorbuffer[f]>31)&(sectorbuffer[f]<128))
		{
			uprintf(display_putc,"%c",sectorbuffer[f]);
		}
		else
		{
			if(sectorbuffer[f]== 0)
				uprintf(display_putc,"-");
			else
				uprintf(display_putc,"#");
		}
	}
	
	printf("\r\nSector: %ld\r\n",nummer);
	printf("DEZ | HEX | _0 _1 _2 _3 _4 _5 _6 _7 _8 _9 _A _B _C _D _E _F |      Text\r\n");
	printf("==============================================================================");
	
	for(f=0;f<512;f=f+16)	
	{
		printf("\r\n%03d | %02X_ | ",f,f/16);
		for(n=0;n<16;n++)
		{
			printf("%02X ",sectorbuffer[f+n]);
		}
		printf("| ");
		
		for(n=0;n<16;n++)
		{
			if((sectorbuffer[f+n]>31)&(sectorbuffer[f+n]<128))
			{
				printf("%c",sectorbuffer[f+n]);
			}
			else
			{
				if(sectorbuffer[f+n]== 0)
					printf("-");
				else
					printf("?");
			}
		}
		
	}
	printf("\r\n\n");
	
}

