//#include  <stdlib.h>
//#include  <string.h>
//#include  <stdio.h>
//#include  <ctype.h>
#include  <io.h>
#include  <signal.h>

#include "lanimacros.h"
#include "rc5.h"

static volatile unsigned int irbuffer[IRBUFFERSIZE];
static volatile unsigned char irschreibzeiger=0;
static volatile unsigned char irlesezeiger=0;




void initRC5(void)
{
	// Comperator
	setBit(P2SEL,BIT3);
	setBit(P2DIR,BIT2);					 // LED Gelb
	
	setBit(CACTL1,CAREF0|CAON|CARSEL|CAEX);
	setBit(CACTL2,P2CA0);
	setBit(CAPD,CAPD3|CAPD4);
	//-------------------------------------------------------------------------------------
	TACTL = TASSEL1 + TACLR + ID0 + ID1;  // SMCLK, clear TAR
	CCTL1 = CCIE + CAP + CCIS0 + CM_NEG;  // CCR0 interrupt enabled
	TACTL |= MC1;                         // Start Timer_A in continuous mode
	
	//----------------------------------------------------------------------------------		
}


unsigned int getRC5(void)
{
	unsigned int tastencode;
	
	if (irlesezeiger==irschreibzeiger)
	{
		return 0xffff;
	}else 
	{
		tastencode=irbuffer[irlesezeiger];
		irlesezeiger++;
		
		if(irlesezeiger>=IRBUFFERSIZE)
			irlesezeiger=0;
		
		return tastencode;
	}
}

// Timer_A3 Interrupt Vector (TAIV) handler   (ist noch nicht benutzt)
interrupt (TIMERA1_VECTOR) wakeup Timer_A1(void)
{
	static unsigned int bitnummer = 0;		// Bitzaehler
	static unsigned int neuerwert = 1;

	static unsigned int alterwert = 0xffff;
	
	switch (TAIV)
	{
		case  2:               // Add Offset to CCR1
			
			CCR2=TAR+2000;		// Timer 2 zum Rücksetzen bei Störungen
			CCTL2 = CCIE;
			
			if(bitIsSet(CCTL1,CAP))    // war ein Flankeninterrupt
			{
				CCR1=CCR1+1335;			// Timer 1 auf den Anfang des nächsten Bit stellen
				CCTL1 = CCIE + CCIS0;
				setBit(P2OUT,BIT2);	
		//setBit(P4OUT,BIT4); 
			}
			else					// war ein Timerinterrupt
			{
				neuerwert=neuerwert<<1;		//Platz für nächstes Bit
				
				if(bitIsSet(CCTL1,SCCI))	//war das Bit high?
				{
					neuerwert++;			//wenn ja, setzen
				}
				
				CCTL1 = CCIE + CAP + CCIS0 + CM_BOTH;   // Capture auf die nächste Flanke ( Sync, Mitte des Bits)
				bitnummer++;
				if(bitnummer==14)
				{
					neuerwert = neuerwert>>1;			    // letzten Syncinterrupt und Bit verwerfen
						
					CCTL1 = CCIE + CAP + CCIS0 + CM_NEG; 	// Trigger auf nächstes Startbit
					
					if(neuerwert!=alterwert)				// nur wenn andere Taste oder Togglebit gesetzt
					//if(1)
					{
						alterwert=neuerwert;
						clearBit(neuerwert,0x800);			//togglebit loeschen
						
						irbuffer[irschreibzeiger]= neuerwert;
						
						irschreibzeiger++;
	
						if(irschreibzeiger>=IRBUFFERSIZE)
							irschreibzeiger=0;
						
						CCTL0 = CCIE;					// Tastenpiep
					}
					bitnummer=0;
					neuerwert=1;
					clearBit(P2OUT,BIT2);			// LED aus
					CCTL2 = 0;						// Timer 2 aus 
					
				}
			}
			break;
		
		case  4:               						// 2. Timer setzt 1. Timer zurück wenn 2ms nichts angekommen ist.	
			CCTL2 = 0;								// Timer 2 aus (this)
			
			CCTL1 = CCIE + CAP + CCIS0 + CM_NEG; 	// Timer 1 auf Startbit
				
			bitnummer=0;							//Variablen rücksetzen
			neuerwert=1;
			clearBit(P2OUT,BIT2);					// LED aus
				
			break;                              
		
		case 10: 				             		// Timer_A3 overflow
			break;
	}
}


interrupt (TIMERA0_VECTOR) Timer_A0(void)
{
	static unsigned int counter = 0;
	
	CCR0=CCR0+250;					// Timer 0 fuer Tastenpiep
	//CCTL0 = CCIE;
	toggleBit(P6OUT,BIT5);
	counter++;
	if(counter>=250)
	{
		setBit(P6OUT,BIT5);
		counter=0;
		CCTL0 = 0;
	}
}

